#!/usr/bin/perl -w
# ------------------------------------------------------------
# Pouziti: Pro TeX - snazi se srovnat vyctova okoli (itemize atd.)
# ----------------------------------------------------------
use English;

$indentstr = "   ";
$indentlen = length($indentstr);
$buf = "";
$indent = 0;
$wrap = 60;
$start = 0;
$mode = 0;
$specmode = 0;

while(<>){
   s/[\n\r\t ]+$//;
   s/^[ \t]+//;
	LOOP:	{
		if(	/[^\\](\%|\&)/	||
				/^\%/ || /^\&/		||
				/\\(begin|end){(document|tabular)}/ ||
				/\\(sub)*(section|paragraph)/
			){	&vypisbuf();
				$mode = 0;
				&vypislokraj(1);
				print $_ ;
				last LOOP;
		}
		if(	/\\item/
			){	&vypisbuf();
				$mode = 1;
				$buf .= " " . $_;
				last LOOP;
		}
		if(	/\\begin{.*(itemi|enume|descri|bittd)/
			){	&vypisbuf();
				if($mode > 0){
					$indent++;
					$specmode++;
					$mode = 0;
				}
				&vypislokraj(1);
				print $_  ;
				$indent++;
				last LOOP;
		}
		if(	/\\end{.*(itemi|enume|descri|bittd)/
			){	&vypisbuf();
				if($mode > 0){
					$mode = 0;
				}
				$indent--;
				&vypislokraj(1);
				if($specmode > 0){
					$specmode--;
					$indent--;
				}
				print $_ ;
				last LOOP;
		}
		if(	/^[ \t]*$/	){
			&vypisbuf();
			print "\n";
			last LOOP;
		}
		$buf .= " " . $_;
      if($_ =~ /.*\\\\(\[.*\])*$/){
        &vypisbuf();
        last LOOP;
      }
	}
}
if($buf ne ""){
	&vypislokraj(0);
	&vypisbuf();
}
print "\n";

sub vypisbuf{
	my $delka = 0;
	my $r = "";
	my $i;
   my @slova;
	local $radku = 0;

	if($buf !~ /^\s*$/ ){
		@slova = split(/[ \t]+/, $buf);
		#$pocetpoli = scalar(@slova);
		for($i = 0; $i < scalar(@slova); $i++){
			$d = length($slova[$i]);
			if($delka + $d > $wrap - $indent * $indentlen){
				if($d > $wrap - $indent * $indentlen){
					if(length($r) > 0){
						&vypislokraj(1);
						print $r;
					}
					&vypislokraj(1);
					print $slova[$i];
					$r = "";
					$delka = 0 	}
				else{
					&vypislokraj(1);
					print $r;
					$r = $slova[$i];
					$delka = $d;
				}	}
			else{
				if($r eq ""){
					$r = $slova[$i];
					$delka = $d		}
				else{
					$r .= " " . $slova[$i];
					$delka += $d + 1;
				}
			}
		}
		if($r ne ""){
			&vypislokraj(1);
			print $r;
			if($mode && $radku){
				$indent--
			}
		}
		$buf = "";
	}
}
		
sub vypislokraj{
   local($novy_radek) = @_;
	my $i;

	if($start++ > 0 && $novy_radek == 1){
		print "\n";
	}
	for($i = 0; $i < $indent; $i++){
		print $indentstr;
	}
	if($mode > 0 && $radku++ == 0){
		$indent++
	}
}
